diff --git a/src/filter_core/filter.c b/src/filter_core/filter.c
index 750ce6be72..3559477378 100644
--- a/src/filter_core/filter.c
+++ b/src/filter_core/filter.c
@@ -1570,13 +1570,14 @@ static void filter_parse_dyn_args(GF_Filter *filter, const char *args, GF_Filter
 				internal_arg = GF_TRUE;
 			}
 			else if (has_meta_args && filter->freg->update_arg) {
+				GF_Err e = GF_OK;
 				if (for_script || !(filter->freg->flags&GF_FS_REG_SCRIPT) ) {
 					GF_PropertyValue argv = gf_props_parse_value(GF_PROP_STRING, szArg, value, NULL, filter->session->sep_list);
 					FSESS_CHECK_THREAD(filter)
-					filter->freg->update_arg(filter, szArg, &argv);
+					e = filter->freg->update_arg(filter, szArg, &argv);
 					if (argv.value.string) gf_free(argv.value.string);
 				}
-				if (!(filter->freg->flags&GF_FS_REG_SCRIPT))
+				if (!(filter->freg->flags&GF_FS_REG_SCRIPT) && (e==GF_OK) )
 					found = GF_TRUE;
 			}
 		}
diff --git a/src/filters/ff_avf.c b/src/filters/ff_avf.c
index 6878e3de8a..019db0c3af 100644
--- a/src/filters/ff_avf.c
+++ b/src/filters/ff_avf.c
@@ -67,9 +67,6 @@ typedef struct
 	GF_List *ipids;
 	GF_List *opids;
 
-	//decode options
-	AVDictionary *options;
-
 	AVFilterGraph *filter_graph;
 	char *filter_desc;
 
@@ -894,9 +891,6 @@ static void ffavf_finalize(GF_Filter *filter)
 	gf_list_del(ctx->opids);
 	if (ctx->filter_desc) gf_free(ctx->filter_desc);
 	if (ctx->frame) av_frame_free(&ctx->frame);
-
-	if (ctx->options) av_dict_free(&ctx->options);
-	return;
 }
 
 static GF_Err ffavf_update_arg(GF_Filter *filter, const char *arg_name, const GF_PropertyValue *arg_val)
@@ -949,13 +943,12 @@ static GF_Err ffavf_update_arg(GF_Filter *filter, const char *arg_name, const GF
 		ret = avfilter_graph_send_command(ctx->filter_graph, szTargetName, arg, arg_value, szCommandRes, 1024, 0);
 		if (ret<0) {
 			GF_LOG(GF_LOG_ERROR, GF_LOG_MEDIA, ("[FFAVF] Failed to execute command %s: %s\n", arg_name, av_err2str(ret) ));
+			return GF_BAD_PARAM;
 		}
+		return GF_OK;
 	}
-	ret = av_dict_set(&ctx->options, arg_name, arg_val->value.string, 0);
-	if (ret<0) {
-		GF_LOG(GF_LOG_ERROR, GF_LOG_MEDIA, ("[FFAVF] Failed to set option %s:%s\n", arg_name, arg_val ));
-	}
-	return GF_OK;
+	//other options are not allowed, they MUST be passed as part of `f` option
+	return GF_NOT_FOUND;
 }
 
 
